/*
 * This file is generated by jOOQ.
 */
package be.lghs.accounting.model.tables;


import be.lghs.accounting.model.Accounting;
import be.lghs.accounting.model.Indexes;
import be.lghs.accounting.model.Keys;
import be.lghs.accounting.model.enums.SubscriptionType;
import be.lghs.accounting.model.tables.records.SubscriptionsRecord;

import java.time.LocalDate;
import java.util.Arrays;
import java.util.List;
import java.util.UUID;

import javax.annotation.processing.Generated;

import org.jooq.Check;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Row8;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.Internal;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.14.9",
        "schema version:accounting_0010"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Subscriptions extends TableImpl<SubscriptionsRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>accounting.subscriptions</code>
     */
    public static final Subscriptions SUBSCRIPTIONS = new Subscriptions();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<SubscriptionsRecord> getRecordType() {
        return SubscriptionsRecord.class;
    }

    /**
     * The column <code>accounting.subscriptions.id</code>.
     */
    public final TableField<SubscriptionsRecord, UUID> ID = createField(DSL.name("id"), SQLDataType.UUID.nullable(false), this, "");

    /**
     * The column <code>accounting.subscriptions.movement_id</code>.
     */
    public final TableField<SubscriptionsRecord, UUID> MOVEMENT_ID = createField(DSL.name("movement_id"), SQLDataType.UUID.nullable(false), this, "");

    /**
     * The column <code>accounting.subscriptions.encoder_id</code>.
     */
    public final TableField<SubscriptionsRecord, UUID> ENCODER_ID = createField(DSL.name("encoder_id"), SQLDataType.UUID.nullable(false), this, "");

    /**
     * The column <code>accounting.subscriptions.member_id</code>.
     */
    public final TableField<SubscriptionsRecord, UUID> MEMBER_ID = createField(DSL.name("member_id"), SQLDataType.UUID.nullable(false), this, "");

    /**
     * The column <code>accounting.subscriptions.type</code>.
     */
    public final TableField<SubscriptionsRecord, SubscriptionType> TYPE = createField(DSL.name("type"), SQLDataType.VARCHAR.nullable(false).asEnumDataType(be.lghs.accounting.model.enums.SubscriptionType.class), this, "");

    /**
     * The column <code>accounting.subscriptions.comment</code>.
     */
    public final TableField<SubscriptionsRecord, String> COMMENT = createField(DSL.name("comment"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>accounting.subscriptions.start_date</code>.
     */
    public final TableField<SubscriptionsRecord, LocalDate> START_DATE = createField(DSL.name("start_date"), SQLDataType.LOCALDATE.nullable(false), this, "");

    /**
     * The column <code>accounting.subscriptions.end_date</code>.
     */
    public final TableField<SubscriptionsRecord, LocalDate> END_DATE = createField(DSL.name("end_date"), SQLDataType.LOCALDATE.nullable(false), this, "");

    private Subscriptions(Name alias, Table<SubscriptionsRecord> aliased) {
        this(alias, aliased, null);
    }

    private Subscriptions(Name alias, Table<SubscriptionsRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>accounting.subscriptions</code> table reference
     */
    public Subscriptions(String alias) {
        this(DSL.name(alias), SUBSCRIPTIONS);
    }

    /**
     * Create an aliased <code>accounting.subscriptions</code> table reference
     */
    public Subscriptions(Name alias) {
        this(alias, SUBSCRIPTIONS);
    }

    /**
     * Create a <code>accounting.subscriptions</code> table reference
     */
    public Subscriptions() {
        this(DSL.name("subscriptions"), null);
    }

    public <O extends Record> Subscriptions(Table<O> child, ForeignKey<O, SubscriptionsRecord> key) {
        super(child, key, SUBSCRIPTIONS);
    }

    @Override
    public Schema getSchema() {
        return Accounting.ACCOUNTING;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.SUBSCRIPTIONS_MOVEMENT_ID_UNIQUE);
    }

    @Override
    public UniqueKey<SubscriptionsRecord> getPrimaryKey() {
        return Keys.SUBSCRIPTIONS_PKEY;
    }

    @Override
    public List<UniqueKey<SubscriptionsRecord>> getKeys() {
        return Arrays.<UniqueKey<SubscriptionsRecord>>asList(Keys.SUBSCRIPTIONS_PKEY);
    }

    @Override
    public List<ForeignKey<SubscriptionsRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<SubscriptionsRecord, ?>>asList(Keys.SUBSCRIPTIONS__SUBSCRIPTIONS_MOVEMENT_ID_FKEY, Keys.SUBSCRIPTIONS__SUBSCRIPTIONS_ENCODER_ID_FKEY, Keys.SUBSCRIPTIONS__SUBSCRIPTIONS_MEMBER_ID_FKEY);
    }

    private transient Movements _movements;
    private transient Users _subscriptionsEncoderIdFkey;
    private transient Users _subscriptionsMemberIdFkey;

    public Movements movements() {
        if (_movements == null)
            _movements = new Movements(this, Keys.SUBSCRIPTIONS__SUBSCRIPTIONS_MOVEMENT_ID_FKEY);

        return _movements;
    }

    public Users subscriptionsEncoderIdFkey() {
        if (_subscriptionsEncoderIdFkey == null)
            _subscriptionsEncoderIdFkey = new Users(this, Keys.SUBSCRIPTIONS__SUBSCRIPTIONS_ENCODER_ID_FKEY);

        return _subscriptionsEncoderIdFkey;
    }

    public Users subscriptionsMemberIdFkey() {
        if (_subscriptionsMemberIdFkey == null)
            _subscriptionsMemberIdFkey = new Users(this, Keys.SUBSCRIPTIONS__SUBSCRIPTIONS_MEMBER_ID_FKEY);

        return _subscriptionsMemberIdFkey;
    }

    @Override
    public List<Check<SubscriptionsRecord>> getChecks() {
        return Arrays.<Check<SubscriptionsRecord>>asList(
              Internal.createCheck(this, DSL.name("subscriptions_check"), "((start_date < end_date))", true)
            , Internal.createCheck(this, DSL.name("subscriptions_end_date_check"), "((date_trunc('month'::text, (end_date + '1 day'::interval)) = (end_date + '1 day'::interval)))", true)
            , Internal.createCheck(this, DSL.name("subscriptions_start_date_check"), "((date_trunc('month'::text, (start_date)::timestamp with time zone) = start_date))", true)
        );
    }

    @Override
    public Subscriptions as(String alias) {
        return new Subscriptions(DSL.name(alias), this);
    }

    @Override
    public Subscriptions as(Name alias) {
        return new Subscriptions(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Subscriptions rename(String name) {
        return new Subscriptions(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Subscriptions rename(Name name) {
        return new Subscriptions(name, null);
    }

    // -------------------------------------------------------------------------
    // Row8 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row8<UUID, UUID, UUID, UUID, SubscriptionType, String, LocalDate, LocalDate> fieldsRow() {
        return (Row8) super.fieldsRow();
    }
}
